From 0e059cdf5fd86297546c63fa8607c24059118832 Mon Sep 17 00:00:00 2001
From: "schwarze@openbsd.org" <schwarze@openbsd.org>
Date: Wed, 25 May 2016 23:48:45 +0000
Subject: [PATCH] upstream commit

To prevent screwing up terminal settings when printing to
 the terminal, for ASCII and UTF-8, escape bytes not forming characters and
 bytes forming non-printable characters with vis(3) VIS_OCTAL. For other
 character sets, abort printing of the current string in these cases.  In
 particular, * let scp(1) respect the local user's LC_CTYPE locale(1); *
 sanitize data received from the remote host; * sanitize filenames, usernames,
 and similar data even locally; * take character display widths into account
 for the progressmeter.

This is believed to be sufficient to keep the local terminal safe
on OpenBSD, but bad things can still happen on other systems with
state-dependent locales because many places in the code print
unencoded ASCII characters into the output stream.

Using feedback from djm@ and martijn@,
various aspects discussed with many others.

deraadt@ says it should go in now, i probably already hesitated too long

Upstream-ID: e66afbc94ee396ddcaffd433b9a3b80f387647e0
---
 Makefile.in     |   2 +-
 progressmeter.c |  51 +++++-----
 scp.c           |  45 +++++----
 sftp-client.c   |   9 +-
 sftp.c          |  46 +++++----
 utf8.c          | 258 ++++++++++++++++++++++++++++++++++++++++++++++++
 utf8.h          |  24 +++++
 7 files changed, 369 insertions(+), 66 deletions(-)
 create mode 100644 utf8.c
 create mode 100644 utf8.h

Index: openssh-7.2p2/Makefile.in
===================================================================
--- openssh-7.2p2.orig/Makefile.in
+++ openssh-7.2p2/Makefile.in
@@ -91,7 +91,7 @@ LIBSSH_OBJS=${LIBOPENSSH_OBJS} \
 	compat.o crc32.o deattack.o fatal.o hostfile.o \
 	log.o match.o md-sha256.o moduli.o nchan.o packet.o opacket.o \
 	readpass.o rsa.o ttymodes.o xmalloc.o addrmatch.o \
-	atomicio.o key.o dispatch.o mac.o uidswap.o uuencode.o misc.o \
+	atomicio.o key.o dispatch.o mac.o uidswap.o uuencode.o misc.o utf8.o \
 	monitor_fdpass.o rijndael.o ssh-dss.o ssh-ecdsa.o ssh-rsa.o dh.o \
 	msg.o progressmeter.o dns.o entropy.o gss-genr.o umac.o umac128.o \
 	ssh-pkcs11.o smult_curve25519_ref.o \
Index: openssh-7.2p2/utf8.c
===================================================================
--- /dev/null
+++ openssh-7.2p2/utf8.c
@@ -0,0 +1,219 @@
+/* $OpenBSD: utf8.c,v 1.1 2016/05/25 23:48:45 schwarze Exp $ */
+/*
+ * Copyright (c) 2016 Ingo Schwarze <schwarze@openbsd.org>
+ *
+ * Permission to use, copy, modify, and distribute this software for any
+ * purpose with or without fee is hereby granted, provided that the above
+ * copyright notice and this permission notice appear in all copies.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
+ * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
+ * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
+ * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
+ * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
+ * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
+ * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
+ */
+
+/*
+ * Utility functions for multibyte-character handling,
+ * in particular to sanitize untrusted strings for terminal output.
+ */
+
+#include "includes.h"
+
+#include <sys/types.h>
+#include <langinfo.h>
+#include <limits.h>
+#include <stdarg.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+#if defined(HAVE_STRNVIS) && defined(HAVE_VIS_H) && !defined(BROKEN_STRNVIS)
+# include <vis.h>
+#endif
+#include <wchar.h>
+
+#include "utf8.h"
+
+static int	 dangerous_locale(void);
+static int	 vasnmprintf(char **, size_t, int *, const char *, va_list);
+
+
+/*
+ * For US-ASCII and UTF-8 encodings, we can safely recover from
+ * encoding errors and from non-printable characters.  For any
+ * other encodings, err to the side of caution and abort parsing:
+ * For state-dependent encodings, recovery is impossible.
+ * For arbitrary encodings, replacement of non-printable
+ * characters would be non-trivial and too fragile.
+ */
+
+static int
+dangerous_locale(void) {
+	char	*loc;
+
+	loc = nl_langinfo(CODESET);
+	return strcmp(loc, "US-ASCII") && strcmp(loc, "UTF-8");
+}
+
+/*
+ * The following two functions limit the number of bytes written,
+ * including the terminating '\0', to sz.  Unless wp is NULL,
+ * they limit the number of display columns occupied to *wp.
+ * Whichever is reached first terminates the output string.
+ * To stay close to the standard interfaces, they return the number of
+ * non-NUL bytes that would have been written if both were unlimited.
+ * If wp is NULL, newline, carriage return, and tab are allowed;
+ * otherwise, the actual number of columns occupied by what was
+ * written is returned in *wp.
+ */
+
+static int
+vasnmprintf(char **str, size_t maxsz, int *wp, const char *fmt, va_list ap)
+{
+	char	*src;	/* Source string returned from vasprintf. */
+	char	*sp;	/* Pointer into src. */
+	char	*dst;	/* Destination string to be returned. */
+	char	*dp;	/* Pointer into dst. */
+	char	*tp;	/* Temporary pointer for dst. */
+	size_t	 sz;	/* Number of bytes allocated for dst. */
+	size_t	 tsz;	/* Temporary size while extending dst. */
+	wchar_t	 wc;	/* Wide character at sp. */
+	int	 len;	/* Number of bytes in the character at sp. */
+	int	 ret;	/* Number of bytes needed to format src. */
+	int	 width;	/* Display width of the character wc. */
+	int	 total_width, max_width, print;
+
+	src = dst = NULL;
+	if (vasprintf(&src, fmt, ap) <= 0)
+		goto fail;
+
+	sz = strlen(src);
+	if ((dst = malloc(sz)) == NULL)
+		goto fail;
+
+	if (maxsz > INT_MAX)
+		maxsz = INT_MAX;
+
+	sp = src;
+	dp = dst;
+	ret = 0;
+	print = 1;
+	total_width = 0;
+	max_width = wp == NULL ? INT_MAX : *wp;
+	while (*sp != '\0') {
+		if ((len = mbtowc(&wc, sp, MB_CUR_MAX)) == -1) {
+			(void)mbtowc(NULL, NULL, MB_CUR_MAX);
+			if (dangerous_locale()) {
+				ret = -1;
+				break;
+			}
+			len = 1;
+			width = -1;
+		} else if (wp == NULL &&
+		    (wc == L'\n' || wc == L'\r' || wc == L'\t')) {
+			/*
+			 * Don't use width uninitialized; the actual
+			 * value doesn't matter because total_width
+			 * is only returned for wp != NULL.
+			 */
+			width = 0;
+		} else if ((width = wcwidth(wc)) == -1 &&
+		    dangerous_locale()) {
+			ret = -1;
+			break;
+		}
+
+		/* Valid, printable character. */
+
+		if (width >= 0) {
+			if (print && (dp - dst >= (int)maxsz - len ||
+			    total_width > max_width - width))
+				print = 0;
+			if (print) {
+				total_width += width;
+				memcpy(dp, sp, len);
+				dp += len;
+			}
+			sp += len;
+			if (ret >= 0)
+				ret += len;
+			continue;
+		}
+
+		/* Escaping required. */
+
+		while (len > 0) {
+			if (print && (dp - dst >= (int)maxsz - 4 ||
+			    total_width > max_width - 4))
+				print = 0;
+			if (print) {
+				if (dp + 4 >= dst + sz) {
+					tsz = sz + 128;
+					if (tsz > maxsz)
+						tsz = maxsz;
+					tp = realloc(dst, tsz);
+					if (tp == NULL) {
+						ret = -1;
+						break;
+					}
+					dp = tp + (dp - dst);
+					dst = tp;
+					sz = tsz;
+				}
+				tp = vis(dp, *sp, VIS_OCTAL | VIS_ALL, 0);
+				width = tp - dp;
+				total_width += width;
+				dp = tp;
+			} else
+				width = 4;
+			len--;
+			sp++;
+			if (ret >= 0)
+				ret += width;
+		}
+		if (len > 0)
+			break;
+	}
+	free(src);
+	*dp = '\0';
+	*str = dst;
+	if (wp != NULL)
+		*wp = total_width;
+
+	/*
+	 * If the string was truncated by the width limit but
+	 * would have fit into the size limit, the only sane way
+	 * to report the problem is using the return value, such
+	 * that the usual idiom "if (ret < 0 || ret >= sz) error"
+	 * works as expected.
+	 */
+
+	if (ret < (int)maxsz && !print)
+		ret = -1;
+	return ret;
+
+fail:
+	free(src);
+	free(dst);
+	*str = NULL;
+	if (wp != NULL)
+		*wp = 0;
+	return -1;
+}
+
+int
+snmprintf(char *str, size_t sz, int *wp, const char *fmt, ...)
+{
+	va_list	 ap;
+	char	*cp;
+	int	 ret;
+
+	va_start(ap, fmt);
+	ret = vasnmprintf(&cp, sz, wp, fmt, ap);
+	va_end(ap);
+	(void)strlcpy(str, cp, sz);
+	free(cp);
+	return ret;
+}
Index: openssh-7.2p2/utf8.h
===================================================================
--- /dev/null
+++ openssh-7.2p2/utf8.h
@@ -0,0 +1,19 @@
+/* $OpenBSD: utf8.h,v 1.1 2016/05/25 23:48:45 schwarze Exp $ */
+/*
+ * Copyright (c) 2016 Ingo Schwarze <schwarze@openbsd.org>
+ *
+ * Permission to use, copy, modify, and distribute this software for any
+ * purpose with or without fee is hereby granted, provided that the above
+ * copyright notice and this permission notice appear in all copies.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
+ * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
+ * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
+ * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
+ * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
+ * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
+ * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
+ */
+
+int	 snmprintf(char *, size_t, int *, const char *, ...)
+	     __attribute__((format(printf, 4, 5)));
Index: openssh-7.2p2/openbsd-compat/vis.h
===================================================================
--- openssh-7.2p2.orig/openbsd-compat/vis.h
+++ openssh-7.2p2/openbsd-compat/vis.h
@@ -58,6 +58,7 @@
 #define	VIS_NL		0x10	/* also encode newline */
 #define	VIS_WHITE	(VIS_SP | VIS_TAB | VIS_NL)
 #define	VIS_SAFE	0x20	/* only encode "unsafe" characters */
+#define	VIS_ALL         0x400   /* encode all characters */
 
 /*
  * other
